<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Desa extends Model
{
    use HasFactory, SoftDeletes;
    protected $fillable = [
        'nama', 'unit_kerja_id'
    ];
    public function UnitKerja(){
        return $this->belongsTo(UnitKerja::class);
    }
    public function IbuHamil(){
        return $this->hasOne(IbuHamilDanBersalin::class);
    }
    public function filterDesa($year = null){
        if($year == null){
            $var = IbuHamilDanBersalin::where('desa_id', $this->id)->whereYear('created_at', Carbon::now()->format('Y'))->first();
            // dd("A");
        } else {
            $var = IbuHamilDanBersalin::where('desa_id', $this->id)->whereYear('created_at', $year)->first();
        }

        return $var;
    }
}
